/*
 * generated by Xtext 2.19.0.M3
 */
package fr.irisa.cairn.graphviz.model.serializer;

import com.google.inject.Inject;
import fr.irisa.cairn.graphviz.model.dotty.ColorAttribute;
import fr.irisa.cairn.graphviz.model.dotty.Compound;
import fr.irisa.cairn.graphviz.model.dotty.CompoundAttribute;
import fr.irisa.cairn.graphviz.model.dotty.DottyPackage;
import fr.irisa.cairn.graphviz.model.dotty.Graph;
import fr.irisa.cairn.graphviz.model.dotty.LabelAttribute;
import fr.irisa.cairn.graphviz.model.dotty.LeafNode;
import fr.irisa.cairn.graphviz.model.dotty.RankAttribute;
import fr.irisa.cairn.graphviz.model.dotty.ShapeAttribute;
import fr.irisa.cairn.graphviz.model.dotty.StyleAttribute;
import fr.irisa.cairn.graphviz.model.dotty.SubNode;
import fr.irisa.cairn.graphviz.model.services.DottyGrammarAccess;
import java.util.Set;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.xtext.Action;
import org.eclipse.xtext.Parameter;
import org.eclipse.xtext.ParserRule;
import org.eclipse.xtext.serializer.ISerializationContext;
import org.eclipse.xtext.serializer.acceptor.SequenceFeeder;
import org.eclipse.xtext.serializer.sequencer.AbstractDelegatingSemanticSequencer;
import org.eclipse.xtext.serializer.sequencer.ITransientValueService.ValueTransient;

@SuppressWarnings("all")
public class DottySemanticSequencer extends AbstractDelegatingSemanticSequencer {

	@Inject
	private DottyGrammarAccess grammarAccess;
	
	@Override
	public void sequence(ISerializationContext context, EObject semanticObject) {
		EPackage epackage = semanticObject.eClass().getEPackage();
		ParserRule rule = context.getParserRule();
		Action action = context.getAssignedAction();
		Set<Parameter> parameters = context.getEnabledBooleanParameters();
		if (epackage == DottyPackage.eINSTANCE)
			switch (semanticObject.eClass().getClassifierID()) {
			case DottyPackage.COLOR_ATTRIBUTE:
				sequence_ColorAttribute(context, (ColorAttribute) semanticObject); 
				return; 
			case DottyPackage.COMPOUND:
				sequence_Compound(context, (Compound) semanticObject); 
				return; 
			case DottyPackage.COMPOUND_ATTRIBUTE:
				sequence_CompoundAttribute(context, (CompoundAttribute) semanticObject); 
				return; 
			case DottyPackage.GRAPH:
				sequence_Graph(context, (Graph) semanticObject); 
				return; 
			case DottyPackage.LABEL_ATTRIBUTE:
				sequence_LabelAttribute(context, (LabelAttribute) semanticObject); 
				return; 
			case DottyPackage.LEAF_NODE:
				sequence_LeafNode(context, (LeafNode) semanticObject); 
				return; 
			case DottyPackage.RANK_ATTRIBUTE:
				sequence_RankAttribute(context, (RankAttribute) semanticObject); 
				return; 
			case DottyPackage.SHAPE_ATTRIBUTE:
				sequence_ShapeAttribute(context, (ShapeAttribute) semanticObject); 
				return; 
			case DottyPackage.STYLE_ATTRIBUTE:
				sequence_StyleAttribute(context, (StyleAttribute) semanticObject); 
				return; 
			case DottyPackage.SUB_NODE:
				sequence_SubNode(context, (SubNode) semanticObject); 
				return; 
			}
		if (errorAcceptor != null)
			errorAcceptor.accept(diagnosticProvider.createInvalidContextOrTypeDiagnostic(semanticObject, context));
	}
	
	/**
	 * Contexts:
	 *     Attribute returns ColorAttribute
	 *     ColorAttribute returns ColorAttribute
	 *
	 * Constraint:
	 *     (color=ID | color=STRING)
	 */
	protected void sequence_ColorAttribute(ISerializationContext context, ColorAttribute semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Attribute returns CompoundAttribute
	 *     CompoundAttribute returns CompoundAttribute
	 *
	 * Constraint:
	 *     (compound='true' | compound=' false')
	 */
	protected void sequence_CompoundAttribute(ISerializationContext context, CompoundAttribute semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Compound returns Compound
	 *
	 * Constraint:
	 *     ((nodes+=Node nodes+=Node*) | attributes+=Attribute | sub+=Compound)+
	 */
	protected void sequence_Compound(ISerializationContext context, Compound semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Graph returns Graph
	 *
	 * Constraint:
	 *     (name=ID body=Compound)
	 */
	protected void sequence_Graph(ISerializationContext context, Graph semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, DottyPackage.Literals.GRAPH__NAME) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, DottyPackage.Literals.GRAPH__NAME));
			if (transientValues.isValueTransient(semanticObject, DottyPackage.Literals.GRAPH__BODY) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, DottyPackage.Literals.GRAPH__BODY));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getGraphAccess().getNameIDTerminalRuleCall_1_0(), semanticObject.getName());
		feeder.accept(grammarAccess.getGraphAccess().getBodyCompoundParserRuleCall_2_0(), semanticObject.getBody());
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     Attribute returns LabelAttribute
	 *     LabelAttribute returns LabelAttribute
	 *
	 * Constraint:
	 *     label=STRING
	 */
	protected void sequence_LabelAttribute(ISerializationContext context, LabelAttribute semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, DottyPackage.Literals.LABEL_ATTRIBUTE__LABEL) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, DottyPackage.Literals.LABEL_ATTRIBUTE__LABEL));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getLabelAttributeAccess().getLabelSTRINGTerminalRuleCall_2_0(), semanticObject.getLabel());
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     Node returns LeafNode
	 *     LeafNode returns LeafNode
	 *
	 * Constraint:
	 *     (name=ID (attributes+=Attribute attributes+=Attribute*)?)
	 */
	protected void sequence_LeafNode(ISerializationContext context, LeafNode semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Attribute returns RankAttribute
	 *     RankAttribute returns RankAttribute
	 *
	 * Constraint:
	 *     (direction='TB' | direction='LR' | direction='BT' | direction='RL')
	 */
	protected void sequence_RankAttribute(ISerializationContext context, RankAttribute semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Attribute returns ShapeAttribute
	 *     ShapeAttribute returns ShapeAttribute
	 *
	 * Constraint:
	 *     (shape=ID | shape=STRING)
	 */
	protected void sequence_ShapeAttribute(ISerializationContext context, ShapeAttribute semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Attribute returns StyleAttribute
	 *     StyleAttribute returns StyleAttribute
	 *
	 * Constraint:
	 *     (style=ID | style=STRING)
	 */
	protected void sequence_StyleAttribute(ISerializationContext context, StyleAttribute semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Node returns SubNode
	 *     SubNode returns SubNode
	 *
	 * Constraint:
	 *     (name=ID body=Compound)
	 */
	protected void sequence_SubNode(ISerializationContext context, SubNode semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, DottyPackage.Literals.NODE__NAME) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, DottyPackage.Literals.NODE__NAME));
			if (transientValues.isValueTransient(semanticObject, DottyPackage.Literals.SUB_NODE__BODY) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, DottyPackage.Literals.SUB_NODE__BODY));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getSubNodeAccess().getNameIDTerminalRuleCall_1_0(), semanticObject.getName());
		feeder.accept(grammarAccess.getSubNodeAccess().getBodyCompoundParserRuleCall_2_0(), semanticObject.getBody());
		feeder.finish();
	}
	
	
}
